; ##############################################################################
; ##############################################################################
; ##############################################################################
EXTERNER_INTERUPT_INITIALISIEREN_AKTIVIEREN:
;																			
; SLEEP+INT0+INT1 (externer Interrupt) konfigurieren						
;																			
; MCUCR => SE SM2 SM1 SM0 ISC11 ISC10 ISC01 ISC00 							
; SM2 SM1 SM0 Sleep Mode													
; 0   0   0   Idle															
; 0   0   1   ADC Noise Reduction											
; 0   1   0   Power-down													
; 0   1   1   Power-save													
; 1   0   0   Reserved														
; 1   0   1   Reserved														
; 1   1   0   Standby(1)													
;																			
;ISC11 ISC10 Description													
; 0 	0 	The low level of INT1 generates an interrupt request.			
; 0 	1 	Any logical change on INT1 generates an interrupt request.		
; 1 	0 	The falling edge of INT1 generates an interrupt request.		
; 1 	1 	The rising edge of INT1 generates an interrupt request.			
;																			
;ISC01 ISC00 Description													
; 0 	0 	The low level of INT0 generates an interrupt request.			
;*0 	1 	Any logical change on INT0 generates an interrupt request.		
; 1 	0 	The falling edge of INT0 generates an interrupt request.		
; 1 	1 	The rising  edge of INT0 generates an interrupt request.		
;																			
	ldi temp,(0<<SE)|(0<<SM2)|(0<<SM1)|(0<<SM0)|(0<<ISC11)|(0<<ISC10)|(0<<ISC01)|(1<<ISC00) 
	out MCUCR,temp
; INT0 aktivieren															
	ldi temp, (0<<INT1)|(1<<INT0)|(0<<IVSEL)|(0<<IVCE)   
    out GICR, temp 
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
EXT_INT0:
	push TEMP		    ; Sichern von "TEMP" im Stack				
	in	 TEMP,SREG		; Einlesen des SREG 						
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)		
	push temp1		    ; Sichern von "TEMP1" im Stack				
	clr temp			; Hilfsregister	clear						
;-------------------------------------------------------------------------------
	; B auslesen 					
	sbic (DREHIMPULSGEBER_B_PIN),(DREHIMPULSGEBER_B_PIN_NR)
	SBR temp,2			; Set Bit(s) in Register					
;-------------------------------------------------------------------------------
EXT_INT0_ENTPRELLUNG_SCHLEIFE:
	; Entprellung					
	out GIFR,VOLL		; eventuell auftretende interrupts lschen	
	rcall wait_1ms		; kurze PAUSE 								
	; traten Interrupts auf ?		
	in temp1,GIFR
	tst temp1
	brne EXT_INT0_ENTPRELLUNG_SCHLEIFE
;-------------------------------------------------------------------------------
	; A auslesen (INT0-PIN)			
	sbic (DREHIMPULSGEBER_A_PIN),(DREHIMPULSGEBER_A_PIN_NR)
	SBR temp,1			; Set Bit(s) in Register					
;-------------------------------------------------------------------------------
	; vergleich				
	cpi  temp,3
	breq EXT_INT0_DREHRICHTUNG_2
	cpi  temp,0
	breq EXT_INT0_DREHRICHTUNG_2
;-------------------------------------------------------------------------------
; Hier knnte der Programmcode ergnzt werden, fr die Drehrichtung-1			
; Anmerkung: die 1ms-Warteschleife dient nur zur Sichtbarmachung der LED		
EXT_INT0_DREHRICHTUNG_1:
	cbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB an	
	rcall wait_1ms
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	rjmp EXT_INT0_FERTIG
;-------------------------------------------------------------------------------
; Hier knnte der Programmcode ergnzt werden, fr die Drehrichtung-2			
; Anmerkung: die 1ms-Warteschleife dient nur zur Sichtbarmachung der LED		
EXT_INT0_DREHRICHTUNG_2:
	cbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN an   
	rcall wait_1ms
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus  
	rjmp EXT_INT0_FERTIG
;-------------------------------------------------------------------------------
EXT_INT0_FERTIG:
	pop temp1			; Wiederherstellen von "TEMP1" 			
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)		
	out	SREG,TEMP		; Wiederherstellen von SREG				
	pop	TEMP			; Wiederherstellen von "TEMP" 			
reti
; ##############################################################################
; ##############################################################################
; ##############################################################################
