;												
; Drehgeber auslesen							
; Bernhard.Erfurt@gmx.de						
; 05/2013										
;												

;												
; Anschlussbelegung PINS						
;												
; PB0 ==>										
; PB1 ==>										
; PB2 ==>										
; PB3 ==>										
; PB4 ==>										
; PB5 ==>										
; PB6 ==>										
; PB7 ==>										
;												
; PC0 ==>										
; PC1 ==>Dregeber KANAL-B (oder A)				
; PC2 ==>Dregeber KANAL-A (oder B)				
; PC3 ==>										
; PC4 ==>										
; PC5 ==>										
;												
; PD0 ==> 										
; PD1 ==> 										
; PD2 ==> 										
; PD3 ==> 										
; PD4 ==> 										
; PD5 ==> LED GRN								
; PD6 ==> LED GELB								
; PD7 ==> LED ROT								
;												


; ATmega8 										
.include "m8def.inc"
; LED-GRUEN										
.equ LED_GRUEN_PIN_NR				= 5
.equ LED_GRUEN_DDR					= DDRD
.equ LED_GRUEN_PORT					= PORTD
; LED-GELB										
.equ LED_GELB_PIN_NR				= 6
.equ LED_GELB_DDR					= DDRD
.equ LED_GELB_PORT					= PORTD
; LED-ROT										
.equ LED_ROT_PIN_NR					= 7
.equ LED_ROT_DDR					= DDRD
.equ LED_ROT_PORT					= PORTD
; Drehimpulsgeber A-SIGNAL						
.equ DREHIMPULSGEBER_A_PIN_NR		= 2
.equ DREHIMPULSGEBER_A_DDR			= DDRD
.equ DREHIMPULSGEBER_A_PORT			= PORTD
.equ DREHIMPULSGEBER_A_PIN			= PIND
; Drehimpulsgeber B-SIGNAL						
.equ DREHIMPULSGEBER_B_PIN_NR		= 1
.equ DREHIMPULSGEBER_B_DDR			= DDRD
.equ DREHIMPULSGEBER_B_PORT			= PORTD
.equ DREHIMPULSGEBER_B_PIN			= PIND
; REGISTER										
.def NULL 	= R12
.def EINS 	= R14
.def VOLL	= R15
.def temp 	= R16
.def temp1 	= R17
.def temp2 	= R18
.def temp3 	= R19
.def temp4 	= R20
.def temp5 	= R21
.def temp6 	= R22
.def temp7 	= R23
.def temp8 	= R24
.def temp9 	= R25

.cseg					;Beginn eines Code-Segmentes
.org 0					;Startadresse=0

rjmp RESET      		; Reset Handler                           				
rjmp EXT_INT0   ; IRQ0 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp EXT_INT1   ; IRQ1 Handler                      	
rjmp INTERRUPT_ERROR	;rjmp TIM2_COMP  ; Timer2 Compare Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM2_OVF   ; Timer2 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_CAPT  ; Timer1 Capture Handler            	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPA ; Timer1 CompareA Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_COMPB ; Timer1 CompareB Handler           	
rjmp INTERRUPT_ERROR	;rjmp TIM1_OVF   	  	; Timer1 Overflow Handler       
rjmp INTERRUPT_ERROR	;rjmp TIM0_OVF   ; Timer0 Overflow Handler           	
rjmp INTERRUPT_ERROR	;rjmp SPI_STC    ; SPI Transfer Complete Handler     	
rjmp INTERRUPT_ERROR	;rjmp ZEICHEN_EINLESEN 	; USART RX Complete Handler     
rjmp INTERRUPT_ERROR	;rjmp USART_UDRE ; UDR Empty Handler                 	
rjmp INTERRUPT_ERROR	;rjmp USART_TXC  ; USART TX Complete Handler         	
rjmp INTERRUPT_ERROR	;rjmp ADC        ; ADC Conversion Complete Handler   	
rjmp INTERRUPT_ERROR	;rjmp EE_RDY     ; EEPROM Ready Handler              	
rjmp INTERRUPT_ERROR	;rjmp ANA_COMP   ; Analog Comparator Handler         	
rjmp INTERRUPT_ERROR	;rjmp TWSI       ; Two-wire Serial Interface Handler 	
rjmp INTERRUPT_ERROR	;rjmp SPM_RDY    ; Store Program Memory Ready Handler	
; Unkorrekten Interrupt Aufruf 						
INTERRUPT_ERROR:
	sbi (LED_GRUEN_PORT),LED_GRUEN_PIN_NR		; GRN aus	
	sbi (LED_GELB_PORT),LED_GELB_PIN_NR			; GELB aus	
	sbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  aus	
	rcall wait_100ms
	cbi (LED_ROT_PORT),LED_ROT_PIN_NR			; ROT  an	
	rcall wait_100ms
	rjmp INTERRUPT_ERROR
RESET:                        
; STACK initialisieren								
	ldi temp, LOW(RAMEND)
    out SPL, temp
    ldi temp, HIGH(RAMEND)
    out SPH, temp
; PORT B initialisieren								
	ldi temp, 0b00000000	; Eingang				
	out DDRB, temp
; PORT B setzen										
	ldi temp, 0b00000000	; Pull UP aus			
	out PORTB, temp				
; PORT C initialisieren								
	ldi temp, 0b00000000	; Eingang				
	out DDRC, temp
; PORT C setzen										
	ldi temp, 0b00000000	; Pull UP aus			
	out PORTC, temp				
; PORT D initialisieren								
	ldi temp, 0b00000000	; Eingang				
	out DDRD, temp
; PORT D setzen										
	ldi temp, 0b00000000	; Pull UP aus			
	out PORTD, temp				
; STARTWERTE										
	; NULL				
	clr NULL
	; EINS				
	ldi temp,1
	mov EINS,temp
	; VOLL				
	ldi temp,255
	mov VOLL,temp
; LED-INITIALISIERUNG								
	rcall LED_INITIALISIERUNG
; LED_TEST											
	rcall LED_TEST
; DREHIMPILSGEBER-INITIALISIERUNG					
	rcall DREHIMPILSGEBER_INITIALISIERUNG
; ext. INTERUPT INITIALISIEREN AKTIVIEREN			
	rcall EXTERNER_INTERUPT_INITIALISIEREN_AKTIVIEREN
; Interrupts freigeben								
	sei
; ##############################################################################
; ##############################################################################
; ##############################################################################
LOOP:

rjmp LOOP
; ##############################################################################
; ##############################################################################
; ##############################################################################
.include "DREHGEBER_INTERRUPT.asm"	; Interrupt						
.include "DREHGEBER_SONSTIGES.asm"	; sonstiges						
.include "DREHGEBER_WAIT_01MHZ.asm"	;  1 MHz						


